Index: /branches/dev_003_CPL/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/dev_003_CPL/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 990)
+++ /branches/dev_003_CPL/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 991)
@@ -300,4 +300,24 @@
 !-----------------------------------------------------------------------
 &namsbc_cpl
+! SEND
+cn_snd_temperature = 'oce only'              ! 'oce only' 'weighted oce and ice' 'mixed oce-ice'
+cn_snd_albedo      = 'none'                  ! 'none' 'weighted ice' 'mixed oce-ice'
+cn_snd_thickness   = 'weighted ice and snow' ! 'none' 'weighted ice and snow'
+cn_snd_current(1)  = 'none'                  ! 'none' 'oce only' 'weighted oce and ice' 'mixed oce-ice'
+cn_snd_current(2)  = 'spherical'             ! 'spherical' 'cartesian'
+cn_snd_current(3)  = 'eastward-northward'    ! 'eastward-northward' or 'local grid'
+cn_snd_current(4)  = 'T'                     ! 'T''U,V'
+! RECEIVE
+cn_rcv_w10m       = 'coupled'               ! 'none' 'coupled'
+cn_rcv_stress(1)  = 'oce and ice'           ! 'oce only' 'oce and ice' 'mixed oce-ice'
+cn_rcv_stress(2)  = 'spherical'             ! 'spherical' 'cartesian'
+cn_rcv_stress(3)  = 'eastward-northward'    ! 'eastward-northward' or 'local grid'
+cn_rcv_stress(4)  = 'U,V,F'                 ! 'T' 'U,V' 'U,V,F' 'U,V,I' 'T,F' 'T,I' 'T,U,V'
+cn_rcv_dqnsdt     = 'coupled'               ! 'none' 'coupled'
+cn_rcv_qsr        = 'conservative'          ! 'conservative' 'oce and ice' 'mixed oce-ice'
+cn_rcv_qns        = 'conservative'          ! 'conservative' 'oce and ice' 'mixed oce-ice'
+cn_rcv_emp        = 'conservative'          ! 'conservative' 'oce and ice' 'mixed oce-ice'
+cn_rcv_runoff     = 'climato'               ! 'coupled' 'climato' 'mixed'
+cn_rcv_calving    = 'none'                  ! 'none' 'coupled'
 /
 !-----------------------------------------------------------------------
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/ice_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/ice_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/ice_2.F90	(revision 991)
@@ -80,9 +80,5 @@
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qfvbq         !: Array used to store energy in case of toral lateral ablation (?)
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   dmgwi         !: Variation of the mass of snow ice
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   albege        !: Albedo of the snow or ice (only for outputs)
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   albecn        !: Albedo of the ocean (only for outputs)
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tauc          !: Cloud optical depth
-
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ui_ice, vi_ice   !: two components of the ice   velocity at I-point (m/s)
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ui_oce, vi_oce   !: two components of the ocean velocity at I-point (m/s)
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/iceini_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/iceini_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/iceini_2.F90	(revision 991)
@@ -73,10 +73,4 @@
          CALL lim_rst_read_2          ! start from a restart file
       ENDIF
-      
-      tn_ice(:,:) = sist(:,:)         ! initialisation of ice temperature   
-      freeze(:,:) = 1.0 - frld(:,:)   ! initialisation of sea/ice cover    
-# if defined key_coupled
-      alb_ice(:,:) = albege(:,:)      ! sea-ice albedo
-# endif
       !
    END SUBROUTINE ice_init_2
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/limistate_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/limistate_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/limistate_2.F90	(revision 991)
@@ -113,7 +113,4 @@
       ui_ice(:,:)   = 0.e0
       vi_ice(:,:)   = 0.e0
-# if defined key_coupled
-      albege(:,:)   = 0.8 * tms(:,:)
-# endif
 
       !---  Moments for advection.             
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/limrst_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/limrst_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/limrst_2.F90	(revision 991)
@@ -112,7 +112,4 @@
       CALL iom_rstput( iter, nitrst, numriw, 'frld'  , frld  (:,:)   )
       CALL iom_rstput( iter, nitrst, numriw, 'sist'  , sist  (:,:)   )
-# if defined key_coupled
-      CALL iom_rstput( iter, nitrst, numriw, 'albege', albege(:,:) )
-# endif
       CALL iom_rstput( iter, nitrst, numriw, 'tbif1' , tbif  (:,:,1) )
       CALL iom_rstput( iter, nitrst, numriw, 'tbif2' , tbif  (:,:,2) )
@@ -198,7 +195,4 @@
       CALL iom_get( numrir, jpdom_autoglo, 'frld'  , frld   )    
       CALL iom_get( numrir, jpdom_autoglo, 'sist'  , sist   )    
-# if defined key_coupled 
-      CALL iom_get( numrir, jpdom_autoglo, 'albege', albege )    
-# endif
       CALL iom_get( numrir, jpdom_autoglo, 'tbif1' , tbif(:,:,1) )    
       CALL iom_get( numrir, jpdom_autoglo, 'tbif2' , tbif(:,:,2) )    
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/limsbc_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/limsbc_2.F90	(revision 991)
@@ -83,8 +83,6 @@
       REAL(wp) ::   zutau , zvtau    ! lead fraction at U- & V-points
       REAL(wp) ::   zu_io , zv_io    ! 2 components of the ice-ocean velocity
-#if defined key_coupled    
       REAL(wp), DIMENSION(jpi,jpj) ::   zalb     ! albedo of ice under overcast sky
       REAL(wp), DIMENSION(jpi,jpj) ::   zalbp    ! albedo of ice under clear sky
-#endif
       REAL(wp) ::   zsang, zmod, zfm
       REAL(wp), DIMENSION(jpi,jpj) ::   ztio_u, ztio_v   ! ocean stress below sea-ice
@@ -215,17 +213,13 @@
 
       freeze(:,:) = 1.0 - frld(:,:)       ! Sea ice cover            
-      tn_ice(:,:) = sist(:,:)             ! Ice surface temperature                      
-
-#if defined key_coupled            
-      !------------------------------------------------!
-      !    Computation of snow/ice and ocean albedo    !
-      !------------------------------------------------!
-      zalb  (:,:) = 0.e0
-      zalbp (:,:) = 0.e0
-
-      CALL albedo_ice( sist, hicif, hsnif, zalbp, zalb )
-
-      alb_ice(:,:) =  0.5 * zalbp(:,:) + 0.5 * zalb (:,:)   ! Ice albedo (mean clear and overcast skys)
-#endif
+             
+      IF ( lk_cpl ) THEN           
+         ! Ice surface temperature 
+         tn_ice(:,:) = sist(:,:)              
+         ! Computation of snow/ice and ocean albedo
+         +++ INTERFACE 3D versus 2D
+         CALL albedo_ice( sist, hicif, hsnif, zalbp, zalb )
+         alb_ice(:,:) =  0.5 * ( zalbp(:,:) + zalb (:,:) )   ! Ice albedo (mean clear and overcast skys)
+      ENDIF
 
       IF(ln_ctl) THEN
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/limthd_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/limthd_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/limthd_2.F90	(revision 991)
@@ -257,8 +257,8 @@
          CALL tab_2d_1d_2( nbpb, fr2_i0_1d  (1:nbpb)     , fr2_i0     , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d_2( nbpb, qns_ice_1d (1:nbpb)     , qns_ice    , jpi, jpj, npb(1:nbpb) )
-#if ! defined key_coupled
-         CALL tab_2d_1d_2( nbpb, qla_ice_1d (1:nbpb)     , qla_ice    , jpi, jpj, npb(1:nbpb) )
-         CALL tab_2d_1d_2( nbpb, dqla_ice_1d(1:nbpb)     , dqla_ice   , jpi, jpj, npb(1:nbpb) )
-#endif
+         IF ( lk_cpl ) THEN 
+            CALL tab_2d_1d_2( nbpb, qla_ice_1d (1:nbpb)     , qla_ice    , jpi, jpj, npb(1:nbpb) )
+            CALL tab_2d_1d_2( nbpb, dqla_ice_1d(1:nbpb)     , dqla_ice   , jpi, jpj, npb(1:nbpb) )
+         ENDIF
          CALL tab_2d_1d_2( nbpb, dqns_ice_1d(1:nbpb)     , dqns_ice   , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d_2( nbpb, tfu_1d     (1:nbpb)     , tfu        , jpi, jpj, npb(1:nbpb) )
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_2/limthd_zdf_2.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 991)
@@ -213,7 +213,4 @@
           zghe     = ( 1.0 - zihe ) * zheshth * ( 2.0 - zheshth )   &
              &     +         zihe   * 0.5 * ( 1.5 + LOG( 2.0 * zheshth ) )
-#if defined key_lim_cp3
-          zghe = 1.0
-#endif 
 
           !---effective conductivities 
@@ -297,19 +294,7 @@
        DO ji = kideb, kiut
           !---computation of the derivative of energy balance function 
-#if defined key_coupled
-#   if defined key_lim_cp2
-          zdfts   =   zksndh(ji)   & ! contribution of the conductive heat flux
-             &      + zrcpdt(ji)   & ! contribution of hsu * rcp / dt
-             &      - dqns_ice_1d(ji)      ! contribution of the total non solar radiation 
-#   else
-          zdfts   =   zksndh(ji)   & ! contribution of the conductive heat flux
-             &      + zrcpdt(ji)    ! contribution of hsu * rcp / dt
-#   endif
-
-#else
           zdfts    =  zksndh(ji)   & ! contribution of the conductive heat flux
              &      + zrcpdt(ji)   & ! contribution of hsu * rcp / dt
              &      - dqns_ice_1d (ji)     ! contribution of the total non solar radiation 
-#endif
           !---computation of the energy balance function 
           zfts    = - z1mi0 (ji) * qsr_ice_1d(ji)   & ! net absorbed solar radiation
@@ -318,7 +303,4 @@
           !---computation of surface temperature increment  
           zdts    = -zfts / zdfts
-#if defined key_lim_cp3
-          zdts = zdts / 3.0
-#endif
           !---computation of the new surface temperature 
           sist_1d(ji) = sist_1d(ji) + zdts
@@ -340,8 +322,8 @@
        DO ji = kideb, kiut
           sist_1d(ji) = MIN( ztsmlt(ji) , sist_1d(ji) )
-#if ! defined key_coupled
-          qns_ice_1d(ji) = qns_ice_1d(ji) + dqns_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
-          qla_ice_1d (ji) = qla_ice_1d (ji) + dqla_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
-#endif
+          IF ( .NOT. lk_cpl ) THEN
+             qns_ice_1d(ji) = qns_ice_1d(ji) + dqns_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
+             qla_ice_1d(ji) = qla_ice_1d(ji) + dqla_ice_1d(ji) * ( sist_1d(ji) - zts_old(ji) )
+          ENDIF
           zfcsu(ji)  = zksndh(ji) * ( ztbif(ji) - sist_1d(ji) )
        END DO
@@ -542,5 +524,11 @@
           !-----------------------------------------------------------------------
           !----change in snow and ice thicknesses due to sublimation or evaporation
-          zdhssub  = parsub * ( qla_ice_1d(ji) / ( rhosn * xsn ) ) * rdt_ice 
+          IF ( .NOT. lk_cpl ) THEN 
+             zdhssub  = parsub * ( qla_ice_1d(ji) / ( rhosn * xsn ) ) * rdt_ice 
+          ELSE IF (parsub == 1) THEN 
+             CALL ctl_stop( 'In coupled mode, use parsub = 0 or send dqla' ) 
+          ELSE
+             zdhssub  = 0.0
+          ENDIF
           zhsn     = h_snow_1d(ji) - zdhssub
           zdhisub  = MAX( zzero , -zhsn ) * rhosn/rhoic
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/ice.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/ice.F90	(revision 991)
@@ -330,6 +330,4 @@
 
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::       &  !:
-      albege ,   &  !: Albedo of the snow or ice (only for outputs)
-      albecn ,   &  !: Albedo of the ocean (only for outputs)
       tauc          !: Cloud optical depth
 
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/iceini.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/iceini.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/iceini.F90	(revision 991)
@@ -57,5 +57,5 @@
       !!   3.0  !  08-03  (M. Vancop) ITD, salinity, EVP-C
       !!----------------------------------------------------------------------
-
+      INTEGER ::   jl
       ! Open the namelist file 
       CALL ctlopn(numnam_ice,'namelist_ice','OLD', 'FORMATTED', 'SEQUENTIAL', 1,numout,.FALSE.,1)
@@ -92,10 +92,4 @@
          CALL lim_var_glo2eqv         ! convert global var in equivalent variables
       ENDIF
-
-      freeze(:,:) = at_i(:,:)   ! initialisation of sea/ice cover    
-# if defined key_coupled
-      Must be adpated to LIM3 
-      alb_ice(:,:,:) = albege(:,:)      ! sea-ice albedo
-# endif
 
       nstart = numit  + nn_fsbc      
@@ -255,6 +249,4 @@
       END DO
 
-      tn_ice(:,:,:) = t_su(:,:,:)
-
    END SUBROUTINE lim_itd_ini
 
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/limistate.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/limistate.F90	(revision 991)
@@ -469,8 +469,4 @@
       stress2_i(:,:)  = 0.0
       stress12_i(:,:) = 0.0
-
-# if defined key_coupled
-      albege(:,:)   = 0.8 * tms(:,:)
-# endif
 
       !--------------------------------------------------------------------
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/limrst.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/limrst.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/limrst.F90	(revision 991)
@@ -138,7 +138,4 @@
          CALL iom_rstput( iter, nitrst, numriw, znam , z2d )
       END DO
-# if defined key_coupled
-      CALL iom_rstput( iter, nitrst, numriw, 'albege', albege(:,:) )
-# endif
       DO jl = 1, jpl 
          WRITE(zchar,'(I1)') jl
@@ -498,7 +495,4 @@
       ENDIF
 
-# if defined key_coupled 
-      CALL iom_get( numrir, jpdom_autoglo, 'albege'   , albege )
-# endif
       DO jl = 1, jpl 
          WRITE(zchar,'(I1)') jl
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/limsbc.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/limsbc.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/limsbc.F90	(revision 991)
@@ -242,8 +242,6 @@
       REAL(wp) ::   zpme             ! freshwater exchanges at the ice/ocean interface
       REAL(wp), DIMENSION(jpi,jpj) ::   zfcm1 , zfcm2    ! solar/non solar heat fluxes
-#if defined key_coupled    
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zalb     ! albedo of ice under overcast sky
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zalbp    ! albedo of ice under clear sky
-#endif
       !!---------------------------------------------------------------------
 
@@ -422,19 +420,14 @@
       !-----------------------------------------------!
 
-      freeze(:,:)   = at_i(:,:)             ! Sea ice cover            
-      tn_ice(:,:,:) = t_su(:,:,:)           ! Ice surface temperature                      
-
-#if defined key_coupled            
-      !------------------------------------------------!
-      !    Computation of snow/ice and ocean albedo    !
-      !------------------------------------------------!
-      zalb  (:,:,:) = 0.e0
-      zalbp (:,:,:) = 0.e0
-
-      CALL albedo_ice( t_su, ht_i, ht_s, zalbp, zalb )
-
-      alb_ice(:,:,:) =  0.5 * zalbp(:,:,:) + 0.5 * zalb (:,:,:)   ! Ice albedo (mean clear and overcast skys)
-#endif
-
+      freeze(:,:)   = at_i(:,:)             ! Sea ice cover  
+
+      IF ( lk_cpl ) THEN                
+         ! Ice surface temperature
+         tn_ice(:,:,:) = t_su(:,:,:)           
+         ! Computation of snow/ice and ocean albedo
+         CALL albedo_ice( t_su, ht_i, ht_s, zalbp, zalb )
+         alb_ice(:,:,:) =  0.5 * ( zalbp(:,:,:) + zalb (:,:,:) )   ! Ice albedo (mean clear and overcast skys)
+      ENDIF
+         
       IF(ln_ctl) THEN
          CALL prt_ctl( tab2d_1=qsr   , clinfo1=' lim_sbc: qsr    : ', tab2d_2=qns , clinfo2=' qns     : ' )
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/limthd.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/limthd.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/limthd.F90	(revision 991)
@@ -314,10 +314,8 @@
             CALL tab_2d_1d( nbpb, fr2_i0_1d  (1:nbpb)     , fr2_i0     , jpi, jpj, npb(1:nbpb) )
             CALL tab_2d_1d( nbpb, qnsr_ice_1d(1:nbpb)     , qns_ice(:,:,jl) , jpi, jpj, npb(1:nbpb) )
-
-#if ! defined key_coupled
-            CALL tab_2d_1d( nbpb, qla_ice_1d (1:nbpb)     , qla_ice(:,:,jl)    , jpi, jpj, npb(1:nbpb) )
-            CALL tab_2d_1d( nbpb, dqla_ice_1d(1:nbpb)     , dqla_ice(:,:,jl)   , jpi, jpj, npb(1:nbpb) )
-#endif
-
+            IF ( lk_cpl ) THEN
+               CALL tab_2d_1d( nbpb, qla_ice_1d (1:nbpb)     , qla_ice(:,:,jl)    , jpi, jpj, npb(1:nbpb) )
+               CALL tab_2d_1d( nbpb, dqla_ice_1d(1:nbpb)     , dqla_ice(:,:,jl)   , jpi, jpj, npb(1:nbpb) )
+            ENDIF
             CALL tab_2d_1d( nbpb, dqns_ice_1d(1:nbpb)     , dqns_ice(:,:,jl)   , jpi, jpj, npb(1:nbpb) )
             CALL tab_2d_1d( nbpb, t_bo_b     (1:nbpb)     , t_bo       , jpi, jpj, npb(1:nbpb) )
Index: /branches/dev_003_CPL/NEMO/LIM_SRC_3/limthd_dh.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 991)
@@ -384,5 +384,12 @@
          ! if qla is positive (upwards), heat goes to the atmosphere, therefore
          ! snow sublimates, if qla is negative (downwards), snow condensates
-         zdh_s_sub(ji)   =  - parsub * qla_ice_1d(ji) / ( rhosn * lsub ) * rdt_ice
+         
+         IF ( .NOT. lk_cpl ) THEN 
+            zdh_s_sub(ji) = - parsub * qla_ice_1d(ji) / ( rhosn * lsub ) * rdt_ice
+         ELSE IF (parsub == 1) THEN 
+            CALL ctl_stop( 'In coupled mode, use parsub = 0 or send dqla' ) 
+         ELSE
+            zdh_s_sub(ji)  = 0.0
+         ENDIF
          dh_s_tot(ji)    =  dh_s_tot(ji) + zdh_s_sub(ji)
          zdhcf           =  ht_s_b(ji) + zdh_s_sub(ji) 
Index: /branches/dev_003_CPL/NEMO/OPA_SRC/DIA/diafwb.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 991)
@@ -8,5 +8,5 @@
    !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
    !!----------------------------------------------------------------------
-#if ( defined key_orca_r2 || defined  key_orca_r4 ) && ! defined key_dynspg_rl && ! defined key_coupled
+#if ( defined key_orca_r2 || defined  key_orca_r4 ) && ! defined key_dynspg_rl && ! defined key_oasis3 && ! defined key_oasis4 
    !!----------------------------------------------------------------------
    !!   NOT "key_dynspg_rl" and "key_orca_r2 or 4"
Index: /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/cpl_oasis3.F90
===================================================================
--- /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 990)
+++ /branches/dev_003_CPL/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 991)
@@ -21,101 +21,40 @@
    !!   cpl_prism_init     : initialization of coupled mode communication
    !!   cpl_prism_define   : definition of grid and fields
-   !!   cpl_prism_send     : send out fields in coupled mode
-   !!   cpl_prism_recv     : receive fields in coupled mode
+   !!   cpl_prism_snd     : snd out fields in coupled mode
+   !!   cpl_prism_rcv     : receive fields in coupled mode
    !!   cpl_prism_finalize : finalize the coupled mode communication
    !!----------------------------------------------------------------------
-   !! * Modules used
-!##################### WARNING coupled mode ###############################
-!##################### WARNING coupled mode ###############################
-!   Following lines must be enabled if coupling with OASIS
+   USE mod_prism_proto              ! OASIS3 prism module
+   USE mod_prism_def_partition_proto! OASIS3 prism module for partitioning
+   USE mod_prism_grids_writing      ! OASIS3 prism module for writing grid files
+   USE mod_prism_put_proto          ! OASIS3 prism module for snding
+   USE mod_prism_get_proto          ! OASIS3 prism module for receiving
+   USE mod_prism_grids_writing      ! OASIS3 prism module for writing grids
+   USE par_oce                      !
+   USE dom_oce                      ! ocean space and time domain
+   USE sbccpl
+   USE in_out_manager               ! I/O manager
+   USE lib_mpp
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   IMPLICIT NONE
+   PRIVATE
 !
-!   USE mod_prism_proto              ! OASIS3 prism module
-!   USE mod_prism_def_partition_proto! OASIS3 prism module for partitioning
-!   USE mod_prism_grids_writing      ! OASIS3 prism module for writing grid files
-!   USE mod_prism_put_proto          ! OASIS3 prism module for sending
-!   USE mod_prism_get_proto          ! OASIS3 prism module for receiving
-!   USE mod_prism_grids_writing      ! OASIS3 prism module for writing grids
-!##################### WARNING coupled mode ###############################
-!##################### WARNING coupled mode ###############################
-#if defined key_mpp_mpi
-   USE lib_mpp, only : mppsize, mpprank ! message passing
-   USE lib_mpp, only : mppsend          ! message passing
-   USE lib_mpp, only : mpprecv          ! message passing
-#endif
-   USE daymod                       ! date and time info
-   USE dom_oce                      ! ocean space and time domain
-   USE sbc_ice                      ! surface boundary condition: ice
-   USE in_out_manager               ! I/O manager
-   USE par_oce                      !
-   USE phycst, only : rt0           ! freezing point of sea water
-
-   USE oce, only: tn, un, vn
-#if defined key_lim2
-   USE ice_2, only: frld, hicif, hsnif
-#endif
-
-   IMPLICIT NONE
-!
-! Exchange parameters for coupling ORCA-LIM with ECHAM5
-!
-#if defined key_cpl_ocevel
-   INTEGER, PARAMETER         :: nsend =  6
-#else
-   INTEGER, PARAMETER         :: nsend =  4
-#endif
-
-#if defined key_cpl_discharge
-   INTEGER, PARAMETER         :: nrecv = 20
-#else
-   INTEGER, PARAMETER         :: nrecv = 17
-#endif
-
-   INTEGER, DIMENSION(nsend)  :: send_id
-   INTEGER, DIMENSION(nrecv)  :: recv_id
-
-   CHARACTER(len=32)          :: cpl_send (nsend)
-   CHARACTER(len=32)          :: cpl_recv (nrecv)
-
-   PRIVATE
-
-   INTEGER                    :: localRank      ! local MPI rank
-   INTEGER                    :: comp_id        ! id returned by prism_init_comp
-
-   INTEGER                    :: range(5)
-
-   INTEGER, PARAMETER         :: localRoot  = 0
-   INTEGER                    :: localSize      ! local MPI size
-   INTEGER                    :: localComm      ! local MPI size
-   LOGICAL                    :: commRank       ! true for ranks doing OASIS communication
-
-   LOGICAL, SAVE              :: prism_was_initialized
-   LOGICAL, SAVE              :: prism_was_terminated
-   INTEGER, SAVE              :: write_grid
-
-   INTEGER                    :: ierror         ! return error code
+   LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .TRUE.   !: coupled flag
+   INTEGER, PUBLIC            :: nlocalComm        ! local MPI size
+   INTEGER                    :: ncomp_id          ! id returned by prism_init_comp
+   INTEGER                    :: nerror            ! return error code
 
    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: exfld  ! Temporary buffer for receiving
-
-#ifdef key_cpl_rootexchg
-   LOGICAL                               :: rootexchg =.true.     ! logical switch 
-#else
-   LOGICAL                               :: rootexchg =.false.    ! logical switch
-#endif
-
-   REAL(wp), DIMENSION(:),   ALLOCATABLE :: buffer ! Temporary buffer for exchange
-   INTEGER, DIMENSION(:,:),  ALLOCATABLE :: ranges ! Temporary buffer for exchange
 
    !! Routine accessibility
    PUBLIC cpl_prism_init
    PUBLIC cpl_prism_define
-   PUBLIC cpl_prism_send
-   PUBLIC cpl_prism_recv
+   PUBLIC cpl_prism_snd
+   PUBLIC cpl_prism_rcv
    PUBLIC cpl_prism_finalize
 
-   PUBLIC send_id, recv_id
-
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Id$
+   !! $Header$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -123,7 +62,5 @@
 CONTAINS
 
-   SUBROUTINE cpl_prism_init( localCommunicator )
-
-      IMPLICIT NONE
+   SUBROUTINE cpl_prism_init
 
       !!-------------------------------------------------------------------
@@ -134,13 +71,4 @@
       !!
       !! ** Method  :   OASIS3 MPI communication 
-      !!--------------------------------------------------------------------
-      !! * Arguments
-      !!
-      INTEGER, INTENT(OUT)       :: localCommunicator
-      !!
-      !! * Local declarations
-      !!
-      CHARACTER(len=4)           :: comp_name      ! name of this PRISM component
-      !!
       !!--------------------------------------------------------------------
       !!
@@ -149,21 +77,12 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~'
       IF(lwp) WRITE(numout,*)
-     
-#if defined key_flx_bulk_monthly || defined key_flx_bulk_daily || defined key_flx_forced_daily
-      IF(lwp)WRITE(numout,cform_err)
-      IF(lwp)WRITE(numout,*) ' key_coupled and key_flx_bulk_* key_flx_forced_daily are incompatible'
-      nstop = nstop + 1
-#endif
-
-      comp_name = 'opa9'
-
+          
       !------------------------------------------------------------------
       ! 1st Initialize the PRISM system for the application
       !------------------------------------------------------------------
 
-      CALL prism_init_comp_proto ( comp_id, comp_name, ierror )
-      IF ( ierror /= PRISM_Ok ) &
-         CALL prism_abort_proto (comp_id, 'cpl_prism_init', 'Failure in prism_init_comp_proto')
-      prism_was_initialized = .true.
+      CALL prism_init_comp_proto ( ncomp_id, 'oceanx', nerror )
+      IF ( nerror /= PRISM_Ok ) &
+         CALL prism_abort_proto (ncomp_id, 'cpl_prism_init', 'Failure in prism_init_comp_proto')
 
       !------------------------------------------------------------------
@@ -171,9 +90,7 @@
       !------------------------------------------------------------------
 
-      CALL prism_get_localcomm_proto ( localComm, ierror )
-      IF ( ierror /= PRISM_Ok ) &
-         CALL prism_abort_proto (comp_id, 'cpl_prism_init','Failure in prism_get_localcomm_proto' )
-
-      localCommunicator = localComm
+      CALL prism_get_localcomm_proto ( nlocalComm, nerror )
+      IF ( nerror /= PRISM_Ok ) &
+         CALL prism_abort_proto (ncomp_id, 'cpl_prism_init','Failure in prism_get_localcomm_proto' )
 
    END SUBROUTINE cpl_prism_init
@@ -181,6 +98,4 @@
 
    SUBROUTINE cpl_prism_define ()
-
-      IMPLICIT NONE
 
       !!-------------------------------------------------------------------
